
%% Vpoet Hik, pouze pro alfa = 0 a 1
function sdruzena_Hik = celkova_Hik (Wj, Hij,pocet_variant) 

% wjk ... vznamnosti kritri, sloupcov
%   - monosti: 
% velmi mal = 'vm',
% mal = 'm',
% prmrn = 'prum',
% vysok = 'v',
% velmi vysok ='vv'

% Hijk ... velk sdruen matice hodnocen variant dle expert a dle kritri, 
    % ve sloupcch jsou kritria, v dcch varianty X1,...,Xn postupn pro kadho kadho experta   
%   - monosti: 
% nulov naplnn = 'n',
% slab naplnn = 's',
% prmrn naplnn = 'prum',
% podstatn naplnn = 'podst',
% pln naplnn = 'u'

% pocet_variant ... poet variant

% sdruzena_Hik ... velk sdruen matice hodnocen variant dle expert se
% tymi sloupci, v kadm je jedna z vznamnch hodnot urujcch 
% lichobnkov fuzzy slo

%% kd
% Jazykov promnn "vznamnost kritria" - vznamy term
vm = [0,0,0.11,0.22]; % velmi mal vznamnost (stejn jako nulov naplnn) vm / n
m = [0.11,0.22,0.33,0.44]; % mal vznamnost (~ slab naplnn)              m / s
p = [0.33,0.44,0.56,0.67]; % prmrn vznamnost (~ prmrn naplnn)    prum / prum
v = [0.56,0.67,0.78,0.89]; % vysok vznamnost (~ podstatn naplnn)        v / podst
vv = [0.78,0.89,1,1]; % velmi vysok vznamnost (~ pln naplnn)          vv / u

pocet_expertu = size(Hij,1)/pocet_variant;
od=1; % udv dek podmatice Hij, zde zan prvn podmatice (na 1. dku)
% podmatice = hodnocen dle k-tho experta
do=pocet_variant; % udv dek podmatice Hij, zde kon prvn podmatice
sdruzena_Hik = zeros(pocet_expertu*pocet_variant,4); % poten matice 

for k = 1:pocet_expertu % pro vechny podmatice
    wjk = Wj(:,k); 
    Hijk = Hij(od:do,:);
 
    Hik = zeros(size(Hijk,1),4); % poten matice Hik - poet variant x 4 (lich. fuzzy sla)
    for j=1:size(Hijk,1) % poet variant
        poc_krit = size(wjk,1); % poet kritri a zrove i poet hodnocen
        % poten vektory:
        lb_levy0 = zeros(poc_krit,1); % vektor levch krajnch hodnot alfa-ez pro alfa=0 
        lb_levy1 = zeros(poc_krit,1); % vektor levch krajnch hodnot alfa-ez pro alfa=1 
        lb_pravy1 = zeros(poc_krit,1); % vektor pravch krajnch hodnot alfa-ez pro alfa=1 
        lb_pravy0 = zeros(poc_krit,1); % vektor pravch krajnch hodnot alfa-ez pro alfa=0 

        % vpoet hodnot do vetor krajnch hodnot alfa-ez
        for i=1:poc_krit
            if wjk(i) == "vm"
                lb_levy0(i) = vm(1); lb_levy1(i) = vm(2); lb_pravy1(i) = vm(3); lb_pravy0(i) = vm(4);
            elseif wjk(i) == "m"
                lb_levy0(i) = m(1); lb_levy1(i) = m(2); lb_pravy1(i) = m(3); lb_pravy0(i) = m(4);
            elseif wjk(i) == "prum"
                lb_levy0(i) = p(1); lb_levy1(i) = p(2); lb_pravy1(i) = p(3); lb_pravy0(i) = p(4);
            elseif wjk(i) == "v"
                lb_levy0(i) = v(1); lb_levy1(i) = v(2); lb_pravy1(i) = v(3); lb_pravy0(i) = v(4);
            elseif wjk(i) == "vv"
                lb_levy0(i) = vv(1); lb_levy1(i) = vv(2); lb_pravy1(i) = vv(3); lb_pravy0(i) = vv(4);
            else
                error('patn zadan vektor vznamnost kritri wjk!')
            end
        end
        %                                                  _____
        %                                                 /     \
        % poten vektory                     lev fce /       \ prav funkce
        hijk_levy0 = zeros(poc_krit,1); % vektor hodnot levch funkc fuzzy sel pro alfa=0 
        hijk_levy1 = zeros(poc_krit,1); % vektor hodnot levch funkc fuzzy sel pro alfa=1 
        hijk_pravy1 = zeros(poc_krit,1); % vektor hodnot pravch funkc fuzzy sel pro alfa=1 
        hijk_pravy0 = zeros(poc_krit,1); % vektor hodnot pravch funkc fuzzy sel pro alfa=0 

        % vpoet hodnot do vektor 
        for i=1:poc_krit
            if Hijk(j,i) == "n"
                hijk_levy0(i) = vm(1); hijk_levy1(i) = vm(2); hijk_pravy1(i) = vm(3); hijk_pravy0(i) = vm(4);
            elseif Hijk(j,i) == "s"
                hijk_levy0(i) = m(1); hijk_levy1(i) = m(2); hijk_pravy1(i) = m(3); hijk_pravy0(i) = m(4);
            elseif Hijk(j,i) == "prum"
                hijk_levy0(i) = p(1); hijk_levy1(i) = p(2); hijk_pravy1(i) = p(3); hijk_pravy0(i) = p(4);
            elseif Hijk(j,i) == "podst"
                hijk_levy0(i) = v(1); hijk_levy1(i) = v(2); hijk_pravy1(i) = v(3); hijk_pravy0(i) = v(4);
            elseif Hijk(j,i) == "u"
                hijk_levy0(i) = vv(1); hijk_levy1(i) = vv(2); hijk_pravy1(i) = vv(3); hijk_pravy0(i) = vv(4);
            else
                error('patn zadan vektor naplnn dlch cl hijk!')
            end
        end

        % MINIMALIZACE A MAXIMALIZACE
        % minimalizovat, alfa = 0
        xa = lb_levy0;
        a = @(w)(sum(w.*hijk_levy0))./(sum(w));
        [~,fval_leva0]=fmincon(a,xa,[],[],[],[],lb_levy0,lb_pravy0);
        x1 = fval_leva0;

        % maximalizovat, alfa = 0
        xb = lb_levy0;
        b = @(w)-(sum(w.*hijk_pravy0))./(sum(w));
        [~,fval_prava0]=fmincon(b,xb,[],[],[],[],lb_levy0,lb_pravy0);
        x4 = -fval_prava0;

        % minimalizovat, alfa = 1
        xc = lb_levy1;
        c = @(w)(sum(w.*hijk_levy1))./(sum(w));
        [~,fval_leva1]=fmincon(c,xc,[],[],[],[],lb_levy1,lb_pravy1);
        x2 = fval_leva1;

        % maximalizovat, alfa = 1
        xd = lb_levy1;
        d = @(w)-(sum(w.*hijk_pravy1))./(sum(w));
        [~,fval_prava1]=fmincon(d,xd,[],[],[],[],lb_levy1,lb_pravy1);
        x3 = -fval_prava1;

        Hik(j,:) = [x1,x2,x3,x4];
    end
    sdruzena_Hik(od:do,:)=Hik;
    od = do+1; % prvn dek dal podmatice
    do = do+pocet_variant; % posledn dek dal podmatice
end


