%% Defuzzifikace
% Funkce, kter vypot tit hodnocen v matici matice_hodnoceni
function [teziste] = defuzzifikace(matice_hodnoceni,upsilon)

% matice_hodnoceni ... celkov hodnocen variant z upsilon*
% usilon = upsilon* ... dkov vektor s indexy variant
%   - nap. uspilon* = {x1,x5,x7} -> upsilon = [1,5,7]
%   - poet variant v upsilon* x 4

a = matice_hodnoceni; % pouze pejmenovn pro jednoduchost
pocet = size(matice_hodnoceni,1); % poet variant
teziste = zeros(pocet,1);
for i = 1:pocet
    teziste(i) = (1/3)*((a(i,4)^2+a(i,3)^2-a(i,2)^2-a(i,1)^2+a(i,4)*a(i,3)-a(i,2)*a(i,1))/(a(i,4)+a(i,3)-a(i,1)-a(i,2)));
end

maximum = max(teziste);
kde=find(teziste==maximum);
nejlepsi_var = upsilon(kde);
disp(['Nejlep varianta je X_',num2str(nejlepsi_var),'.'])
end