%% Vpoet theta a xi pro dan r a s
function [theta,xi] = vypocet(sdruzena_Hik,r,s,zeta,pocet_variant,pocet_expertu)

% sdruzena_Hik, zeta, pocet_variant z pedelch skript
% r ... r-t stupe pijatelnosti varianty -> Ar
% s ... s-t mnostv expert
% pocet_expertu ... poet expert

%% vpoet thety
% jazykov termy pijatelnosti varianty
A5 = [0,0,1,1];
A4 = [0.25,0.35,1,1];
A3 = [0.5,0.6,1,1];
A2 = [0.75,0.8,1,1];
A1 = [0.9,0.95,1,1];

R = [A1;A2;A3;A4;A5];
Ar = R(r,:); % vybereme r-t stupe pijatelnosti 

krok = 0.00001;
x = 0:krok:1;
y1 = trapmf(x,Ar);

theta = zeros(pocet_variant,pocet_expertu); % poten theta
od = 1; % prvn dek podmatice thety - pro 1. experta
do = pocet_variant; % posledn dek podmatice thety - pro 1. experta

for k=1:pocet_expertu % postupn spotme pro vechny podmatice
    Hik_vnitrni = sdruzena_Hik(od:do,:);
    theta_vnitrni = zeros(pocet_variant,1);

    for i = 1:pocet_variant
        y2 = trapmf(x,Hik_vnitrni(i,:));
        theta_vnitrni(i)=max(min(y1,y2)); % vpoet thet pro danho experta
    end
    theta(:,k)=theta_vnitrni; % zpis do celkov matice thet
    od = do+1; % prvn dek dal podmatice
    do = do+pocet_variant; % posledn dek dal podmatice
end

%% vpoet xi
% jazykov termy mnostv expert
Q1 = [0.8,0.85,1,1];
Q2 = [0.6,0.65,1,1];
Q3 = [0.35,0.4,1,1];
Q4 = [0,0,1,1];


Q = [Q1;Q2;Q3;Q4];
Qs = Q(s,:);

% xi
xi = zeros(pocet_variant,1);

for i=1:pocet_variant
    minima=min(theta(i,:),zeta); % porovnn hodnot z danch vektr a uren minim
    xi(i) = trapmf(sum(minima)/sum(zeta),Qs);    
end

end
