%% Vpoet zeta
function zeta = vypocet_zeta(l)
% l ... zpsobilost expert - dkov vektor
%   - monosti: 
% extrmn mal = "em",
% velmi mal = "vm",
% mal = "m",
% prmrn = "p",
% vysok = "v",
% velmi vysok = "vv",
% extrmn vysok = "ev"

% zeta ... dkov vektor vznamnost expert

krok = 0.00001;
x = 0:krok:1;

B = [0.3,0.8,1,1];
yB = trapmf(x,B);

em = [0,0,0.08,0.15];
vm = [0.08,0.15,0.23,0.31];
m = [0.23,0.31,0.38,0.46];
prum = [0.38,0.46,0.54,0.62];
v = [0.54,0.62,0.69,0.77];
vv = [0.69,0.77,0.85,0.92];
ev = [0.85,0.92,1,1];

pocet_expertu = size(l,2);
zeta = zeros(1,pocet_expertu);

for k = 1:pocet_expertu
    if l(k) == "em"
        yL = trapmf(x,em);
    elseif l(k) == "vm"
        yL = trapmf(x,vm);
    elseif l(k) == "m"
        yL = trapmf(x,m);
    elseif l(k) == "prum"
        yL = trapmf(x,prum);
    elseif l(k) == "v"
        yL = trapmf(x,v);
    elseif l(k) == "vv"
        yL = trapmf(x,vv);
    elseif l(k) == "ev"
        yL = trapmf(x,ev);
    else
        error('patn zadan vektor zpsobilost expert!')
    end
    
    zeta(k) = max(min(yB,yL));
end
end